var cq_sdk;
!function (t) {
    t.version = 'ver1.2';//SDK版本
    t.loghost = '';//日志请求链接
    t.token = '';//token
    t.username = '';//用户日志
    t.loginTime = '';
    t.platform = '';//平台标记

    /**
     * 拼接url 
     * @param rootPath 路径前缀
     * @param urls 路径
     * @param results 结果<不传直接修改原urls>
     * */
    t.assetUrls = function (rootPath, urls, results) {
        if (!rootPath || !urls) return;
        if (!results) results = urls;
        for (var i = 0; i < urls.length; i++) {
            results[i] = rootPath + urls[i];
        }
        return results;
    };

    /**
     * 加载JS队列
     * @param list js路径队列
     * @param callBack 加载完毕回调
     * @param progressBack 进度回调
     */
    t.loadScripts = function (list, callBack, progressBack) {
        if (!list || !list.length) return;
        var loaded = 0;
        var loadNext = function () {
            t.loadSingleScript(list[loaded], function () {
                loaded++;
                if (loaded >= list.length) {
					if (progressBack) progressBack(loaded);
                    callBack();
                } else {
                    if (progressBack) progressBack(loaded);
                    loadNext();
                }
            })
        };
        loadNext();
    };

    /**
     * 加载单个JS
     * @param src
     * @param callBack
     */
    t.loadSingleScript = function (src, callback) {
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.crossOrigin = 'anonymous';
        if (script.readyState) {//IE
            script.onreadystatechange = function () {
                if (script.readyState == "loaded" || script.readyState == "complete") {
                    script.onreadystatechange = null;
                    callback();
                }
            };
        } else {//Others
            script.onload = function () {
                callback();
            }
        }
        script.onerror = function () { }
        script.src = src;
        document.body.appendChild(script);
    };

      /**
     * 日志 
     * @param msg 内容
     * */
    t.log = function (msg) {
        if (!t.loghost || !t.token || !t.username || !msg) return;
        var params = ["msg"  + "=" + encodeURIComponent(msg.msg) + "ua=" + window.navigator.userAgent.toLocaleLowerCase()];
		params.push("type" + "=" + encodeURIComponent(msg.type));
		params.push("step" + "=" + encodeURIComponent(msg.step));
        params.push("token" + "=" + encodeURIComponent(t.token));
        params.push("logintime" + "=" + encodeURIComponent(t.logintime));
        params.push("username" + "=" + encodeURIComponent(t.username));
        params.push("platformId" + "=" + encodeURIComponent(t.platformId));
		
        var httpUrl = t.loghost+"?"+params.join('&');
        t.httpRequest({ httpUrl: httpUrl});
    };

    /**
     * 通用HTTP请求
     * @param paramObj 参数 PS: var paramObj = {httpUrl:"",type:"get",data:{id:xxx,name:""}}
     * @param callback 完成回调
     * @param errBack 失败回调
     */
    t.httpRequest = function (paramObj, callBack, errBack) {
        var xmlhttp = null;
        if (window.XMLHttpRequest) {
            xmlhttp = new XMLHttpRequest();
        } else if (window.ActiveXObject) {
            xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        if (xmlhttp == null) {
            console.error('你的浏览器不支持XMLHttp');
            errBack();
            return;
        }
        var httpType = (paramObj.type || 'GET').toUpperCase();
        var httpUrl = paramObj.httpUrl || '';
        var async = paramObj.async || true;
        /*请求参数--post请求参数格式为：foo=bar&lorem=ipsum*/
        var paramData = paramObj.data || [];
        var requestData = '';
        for (var name in paramData) {
            requestData += name + '=' + paramData[name] + '&';
        }
        requestData = requestData == '' ? '' : requestData.substring(0, requestData.length - 1);
        xmlhttp.onreadystatechange = function () {
            if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                if (callBack) callBack(xmlhttp.responseText);
            } else {
                if (errBack) errBack();
            }
        }
        if (httpType == 'GET') {
            xmlhttp.open("GET", httpUrl, async);
            xmlhttp.send(null);
        } else if (httpType == 'POST') {
            xmlhttp.open("POST", httpUrl, async);
            xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            xmlhttp.send(requestData);
        }
    };

    /**启动egret引擎 */
    t.startEgret = function () {
        var u = window.navigator.userAgent.toLocaleLowerCase();
        var rendMode = "webgl";
        if (u.indexOf("android") > -1 || u.indexOf("linux") > -1) {
            num = u.substr(u.indexOf("android") + 8, 3);
            if ((/4.|5./i).test(num)) {
                rendMode = "canvas";
            }
        }
        egret.runEgret({
            renderMode: rendMode, audioType: 0, calculateCanvasScaleFactor: function (context) {
                var backingStore = context.backingStorePixelRatio ||
                    context.webkitBackingStorePixelRatio ||
                    context.mozBackingStorePixelRatio ||
                    context.msBackingStorePixelRatio ||
                    context.oBackingStorePixelRatio ||
                    context.backingStorePixelRatio || 1;
                return (window.devicePixelRatio || 1) / backingStore;
            }
        });
    };
	var lastError = "";
    /**js脚本错误捕捉 */
    window.onerror = function (message, url, lineNumber, columnNo, error) {
        var msg = message;
        if (error && error.stack) {
            msg = error.stack;
			var errInfo = /\/([^\/]*?)\.js:(\d+):(\d+)/gi.exec(msg);
			if(errInfo && errInfo.length>=1)
			{
				/**var jsName = errInfo[1];
				var line = errInfo[2];
				var row = errInfo[3];
				**/
				if(lastError == errInfo[0])
				{
					return;
				}
				lastError = errInfo[0];
			}
        }
        var err = {};
        err.msg = msg;
        err.type = 3;
        err.step = 0;
        msg += "00";
        err.sign = msg.charAt(0) + msg.charAt(1);
        t.log(err);
    };
}(cq_sdk || (cq_sdk = {}));